/**
 * \file
 * \copyright
 * Copyright (c) 2012-2025, OpenGeoSys Community (http://www.opengeosys.org)
 *            Distributed under a Modified BSD License.
 *              See accompanying file LICENSE.txt or
 *              http://www.opengeosys.org/project/license
 *
 */

#pragma once

#include <vector>

#include "NumLib/NumericsConfig.h"

namespace MeshLib
{
class Mesh;
}

namespace NumLib
{
class LocalToGlobalIndexMap;

/**
 * \brief Computes a sparsity pattern for the given inputs.
 *
 * \param dof_table            maps mesh nodes to global indices
 * \param mesh                 mesh for which the two parameters above are
 * defined
 *
 * \return The computed sparsity pattern.
 */
GlobalSparsityPattern computeSparsityPattern(
    LocalToGlobalIndexMap const& dof_table, MeshLib::Mesh const& mesh);
}  // namespace NumLib
