# OpenGeoSys 6

[![Modified BSD License](http://img.shields.io/badge/license-BSD-blue.svg?style=flat-square)](https://gitlab.opengeosys.org/ogs/ogs/-/blob/master/LICENSE.txt)
[![DOI](https://zenodo.org/badge/1701384.svg)](https://zenodo.org/badge/latestdoi/1701384)

[OpenGeoSys][ogs] (OGS) is a scientific open source project for the development of
numerical methods for the simulation of thermo-hydro-mechanical-chemical
(THMC) processes in porous and fractured media. OGS is implemented in C++, it
is object-oriented with an focus on the numerical solution of coupled multi-field
problems (multi-physics). Parallel versions of OGS are available relying on
both MPI and OpenMP concepts. Application areas of OGS are currently CO2
sequestration, geothermal energy, water resources management, hydrology and
waste deposition. OGS is comprised of the THMC-simulator (simply referred to as
*OGS*) and a visualization tool (*Data Explorer*). OGS is developed by the
[OpenGeoSys Community][ogs].

## Software development

- Good starting point for users as well as for developers is the [documentation][documentation]
- Check your code against our [style guide](http://ufz.github.io/styleguide/cppguide.xml)
- Have a look at the [source code documentation for the current master-branch build][docs-master] or [for the latest release][docs-release]

## License

OpenGeoSys is distributed under the Modified BSD License. See the
[LICENSE.txt][license-source] for the license text.

[ogs]: https://www.opengeosys.org
[documentation]: https://www.opengeosys.org/docs/
[docs-master]: https://doxygen.opengeosys.org/
[docs-release]: https://doxygen.opengeosys.org/6.5.4
[license-source]: https://github.com/ufz/ogs/blob/master/LICENSE.txt
